// 
// Decompiled by Procyon v1.0-SNAPSHOT
// 

package UpFront;

import VASSAL.configure.StringConfigurer;
import javax.swing.KeyStroke;
import VASSAL.configure.HotKeyConfigurer;
import VASSAL.tools.KeyStrokeListener;
import VASSAL.configure.IconConfigurer;
import javax.swing.JButton;
import VASSAL.configure.PlayerIdFormattedStringConfigurer;
import VASSAL.configure.Configurer;
import VASSAL.build.AutoConfigurable;
import VASSAL.configure.ConfigurerFactory;
import VASSAL.command.Command;
import VASSAL.build.module.Chatter;
import java.awt.event.ActionEvent;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import VASSAL.configure.StringArrayConfigurer;
import VASSAL.build.AbstractToolbarItem;
import VASSAL.build.module.documentation.HelpFile;
import VASSAL.build.GameModule;
import VASSAL.build.Buildable;
import VASSAL.build.module.Map;
import VASSAL.tools.FormattedString;
import java.awt.Component;
import javax.swing.JPopupMenu;
import java.awt.event.ActionListener;
import VASSAL.build.AbstractConfigurable;

public class Messenger extends AbstractConfigurable implements ActionListener
{
    protected NewLaunchButton launch;
    protected JPopupMenu popup;
    protected Component owner;
    protected String[] messages;
    protected FormattedString format;
    Map map;
    protected String reportFormat;
    protected Messenger me;
    public static final String HOTKEY = "hotkey";
    public static final String BUTTON_TEXT = "text";
    public static final String NAME = "name";
    public static final String ICON = "icon";
    public static final String FORMAT = "format";
    public static final String MESSAGES = "messages";
    public static final String MESSAGE = "message";
    
    public Messenger() {
        this.messages = new String[0];
        this.format = new FormattedString();
        this.map = null;
        this.reportFormat = "$message$";
        final ActionListener al = e -> this.selectAndSendMessage();
        this.launch = new NewLaunchButton(null, "text", "hotkey", "icon", al);
        this.setAttribute("name", "Messenger");
        this.setAttribute("text", "Messages");
        this.launch.setToolTipText("Generate Counter Inventory");
        this.setConfigureName("Chat Messenger");
        this.me = this;
    }
    
    public void addTo(final Buildable b) {
        this.launch.setAlignmentY(0.0f);
        if (b instanceof Map) {
            this.map = (Map)b;
            this.map.getToolBar().add(this.launch);
            if (this.map.shouldDockIntoMainWindow()) {
                this.owner = (Component)GameModule.getGameModule().getPlayerWindow();
            }
            else {
                this.owner = this.map.getView();
            }
        }
        else {
            GameModule.getGameModule().getToolBar().add(this.launch);
            this.owner = (Component)GameModule.getGameModule().getPlayerWindow();
        }
    }
    
    public void removeFrom(final Buildable b) {
        if (b instanceof Map) {
            ((Map)b).getToolBar().remove(this.launch);
        }
        else {
            GameModule.getGameModule().getToolBar().remove(this.launch);
        }
    }
    
    public HelpFile getHelpFile() {
        return null;
    }
    
    public Class[] getAllowableConfigureComponents() {
        return new Class[0];
    }
    
    public String[] getAttributeDescriptions() {
        return new String[] { "Name", "Button text", "Button icon", "Messages", "Message Format" };
    }
    
    public Class[] getAttributeTypes() {
        return new Class[] { String.class, String.class, AbstractToolbarItem.IconConfig.class, listConfig.class, formatConfig.class };
    }
    
    public String[] getAttributeNames() {
        return new String[] { "name", "text", "icon", "messages", "format" };
    }
    
    public void setAttribute(final String key, Object o) {
        if ("name".equals(key)) {
            this.setConfigureName((String)o);
            this.launch.setToolTipText((String)o);
        }
        else if ("messages".equals(key)) {
            if (o instanceof String) {
                o = StringArrayConfigurer.stringToArray((String)o);
            }
            this.messages = (String[])o;
        }
        else if ("format".equals(key)) {
            this.reportFormat = (String)o;
        }
        else {
            this.launch.setAttribute(key, o);
        }
    }
    
    public String getAttributeValueString(final String key) {
        if ("name".equals(key)) {
            return this.getConfigureName();
        }
        if ("messages".equals(key)) {
            return StringArrayConfigurer.arrayToString(this.messages);
        }
        return "format".equals(key) ? this.reportFormat : this.launch.getAttributeValueString(key);
    }
    
    public void selectAndSendMessage() {
        if (this.popup == null) {
            this.buildPopup();
        }
        final int x = this.launch.getX() + ((this.map == null) ? 0 : this.launch.getParent().getBounds().x);
        final int y = this.launch.getY();
        this.popup.show(this.owner, x, y);
    }
    
    protected void buildPopup() {
        JMenu subMenu = null;
        (this.popup = new JPopupMenu()).addPopupMenuListener(new PopupMenuListener() {
            @Override
            public void popupMenuCanceled(final PopupMenuEvent evt) {
                Messenger.this.owner.repaint();
            }
            
            @Override
            public void popupMenuWillBecomeInvisible(final PopupMenuEvent evt) {
                Messenger.this.owner.repaint();
            }
            
            @Override
            public void popupMenuWillBecomeVisible(final PopupMenuEvent evt) {
            }
        });
        for (final String message : this.messages) {
            if (message.charAt(0) == '>') {
                if (subMenu != null) {
                    this.popup.add(subMenu);
                }
                subMenu = new JMenu(message.substring(1));
            }
            else {
                final JMenuItem item = new JMenuItem(message);
                item.addActionListener(this);
                if (subMenu == null) {
                    this.popup.add(item);
                }
                else {
                    subMenu.add(item);
                }
            }
        }
        if (subMenu != null) {
            this.popup.add(subMenu);
        }
    }
    
    protected void addItem(final JMenu menu, final String item) {
        final JMenuItem messageItem = new JMenuItem(item);
        messageItem.addActionListener(this);
        menu.add(messageItem);
    }
    
    public void actionPerformed(final ActionEvent e) {
        final String message = e.getActionCommand();
        this.format.setFormat(this.reportFormat);
        this.format.setProperty("message", message);
        final String formattedMessage = this.format.getText();
        final Command c = (Command)new Chatter.DisplayText(GameModule.getGameModule().getChatter(), formattedMessage);
        c.execute();
        GameModule.getGameModule().sendAndLog(c);
    }
    
    public static class formatConfig implements ConfigurerFactory
    {
        public Configurer getConfigurer(final AutoConfigurable c, final String key, final String name) {
            return (Configurer)new PlayerIdFormattedStringConfigurer(key, name, new String[] { "message" });
        }
    }
    
    public static class listConfig implements ConfigurerFactory
    {
        public Configurer getConfigurer(final AutoConfigurable c, final String key, final String name) {
            return (Configurer)new StringArrayConfigurer(key, name, (Object)new String[] { "message" });
        }
    }
    
    public static class NewLaunchButton extends JButton
    {
        private final String nameAtt;
        private final String keyAtt;
        private final String iconAtt;
        private final IconConfigurer iconConfig;
        private String toolTipText;
        private final KeyStrokeListener keyListener;
        private Configurer nameConfig;
        private Configurer keyConfig;
        
        public NewLaunchButton(final String name, final String nameAttribute, final String hotkeyAttribute, final ActionListener al) {
            this(name, nameAttribute, hotkeyAttribute, null, al);
        }
        
        public NewLaunchButton(final String name, final String nameAttribute, final String hotkeyAttribute, final String iconAttribute, final ActionListener al) {
            super(name);
            this.nameAtt = nameAttribute;
            this.keyAtt = hotkeyAttribute;
            this.iconAtt = iconAttribute;
            this.iconConfig = new IconConfigurer(this.iconAtt, (String)null, (String)null);
            this.setAlignmentY(0.0f);
            this.keyListener = new KeyStrokeListener(e -> {
                if (this.isEnabled() && this.isShowing()) {
                    al.actionPerformed(e);
                }
                return;
            });
            GameModule.getGameModule().addKeyStrokeListener(this.keyListener);
            this.addActionListener(al);
        }
        
        @Override
        protected void fireActionPerformed(final ActionEvent event) {
            super.fireActionPerformed(event);
        }
        
        public String getNameAttribute() {
            return this.nameAtt;
        }
        
        public String getHotkeyAttribute() {
            return this.keyAtt;
        }
        
        public String getIconAttribute() {
            return this.iconAtt;
        }
        
        public String getAttributeValueString(final String key) {
            if (key.equals(this.nameAtt)) {
                return this.getText();
            }
            if (key.equals(this.keyAtt)) {
                return HotKeyConfigurer.encode(this.keyListener.getKeyStroke());
            }
            return key.equals(this.iconAtt) ? this.iconConfig.getValueString() : null;
        }
        
        public void setAttribute(final String key, Object value) {
            if (key.equals(this.nameAtt)) {
                this.setText((String)value);
            }
            else if (key.equals(this.keyAtt)) {
                if (value instanceof String) {
                    value = HotKeyConfigurer.decode((String)value);
                }
                this.keyListener.setKeyStroke((KeyStroke)value);
                this.setToolTipText(this.toolTipText);
            }
            else if (key.equals(this.iconAtt) && value instanceof String) {
                this.iconConfig.setValue((String)value);
                this.setIcon(this.iconConfig.getIconValue());
            }
        }
        
        @Override
        public void setToolTipText(String text) {
            this.toolTipText = text;
            if (this.keyListener.getKeyStroke() != null) {
                text = (String)(text == null ? "" : (String)text + " ") + "[" + HotKeyConfigurer.getString((KeyStroke)this.keyListener.getKeyStroke()) + "]";
            }
            super.setToolTipText(text);
        }
        
        public Configurer getNameConfigurer() {
            if (this.nameConfig == null && this.nameAtt != null) {
                this.nameConfig = (Configurer)new StringConfigurer(this.nameAtt, "Button text", this.getText());
            }
            return this.nameConfig;
        }
        
        public Configurer getHotkeyConfigurer() {
            if (this.keyConfig == null && this.keyAtt != null) {
                this.keyConfig = (Configurer)new HotKeyConfigurer(this.keyAtt, "Hotkey", this.keyListener.getKeyStroke());
            }
            return this.keyConfig;
        }
    }
}
